import { BehaviorSubject, Observable } from 'rxjs';
import type { Message, Socket, SocketConnectOptions, SocketReconnectOptions } from '../../../connect';
import { SocketSubject } from '../../../connect';
/**
 * @internal
 */
export declare class SocketMock implements Socket {
    isConfigured: boolean;
    isDisconnected: boolean;
    isDisconnectedByServer: boolean;
    hasValidSession: boolean;
    isConnecting: boolean;
    isConnected: boolean;
    isConnectedSubject: BehaviorSubject<boolean>;
    isReconnecting: boolean;
    nextMessage: Message;
    socketMessagesSubject: SocketSubject<Message<any>>;
    connect(host: string, options?: SocketConnectOptions, reconnectOptions?: SocketReconnectOptions): Promise<boolean>;
    disconnect(): void;
    send<T>(message: Message<any>): Promise<Message | any>;
    sendForStream<T>(message: Message<any>, onMessage: Function, onError: Function, onComplete?: Function): Observable<Message>;
    socketMessages(): SocketSubject<Message>;
    reset(): void;
}
//# sourceMappingURL=socket.d.ts.map