import { SocketObservable } from '../../../connect';
import { Datasource, DatasourceOptions, Dataview, ResourceType } from '../../../datasource';
import { FieldMetadata, FilteredDataServerResult, RequestServerResult } from '../../../metadata';
/**
 * @internal
 */
export declare class DatasourceMock implements Datasource {
    initialized: boolean;
    fieldMetadata: FieldMetadata[];
    readOnly: boolean;
    resourceType: ResourceType;
    stream: SocketObservable<FilteredDataServerResult | RequestServerResult>;
    init(options: DatasourceOptions, fetchMeta: boolean): Promise<boolean>;
    deinit(): void;
    destroy(): void;
    validResourceName(resourceName: string): boolean;
    getMetadata?(resourceName: string): Promise<FieldMetadata[]>;
    snapshot(params?: any): void;
    snapshotFiltered(rowId?: string): void;
    updateData?(data: any[]): Promise<void>;
    dataHandler?(data: any[]): any[];
    addView?(view: Dataview): void;
    dropView?(view: Dataview): void;
    setFilter?(name: string, value: any, type?: string): Promise<void>;
    clearFilter?(name: string): Promise<void>;
    createItem?(data: any): Promise<string>;
    deleteItem?(itemId: string): Promise<void>;
    updateItem?(itemId: string, data: any): Promise<void>;
}
//# sourceMappingURL=datasource.d.ts.map