import type { UserPermission, UserProfile } from './user.types';
/**
 * Made some minor adjustments here to make user more accessible in the short term.
 * Please note that this User will be replaced with the enhanced version shortly!
 */
/**
 * TODO: Evolve, re-locate to foundation-data, foundation-user or similar and add JSON schema based population,
 * validation, evolution, foundation-store interop etc.
 */
/**
 * Represents the core options for a user.
 * @internal
 */
interface UserOptions {
    readonly permissions: UserPermission[] | null;
    readonly profiles: UserProfile[] | null;
    readonly username: string | null;
}
/**
 * Represents a User object with associated permissions and profiles.
 * @public
 */
export interface User extends UserOptions {
    hasAdminProfile(): boolean;
    hasPermission(permission: UserPermission | UserPermission[]): boolean;
    hasProfile(profile: UserProfile | UserProfile[]): boolean;
    set(options: UserOptions): void;
    unset(): void;
}
/**
 * Represents the current user (i.e. the user that is currently logged in).
 * @public
 */
export declare class CurrentUser implements User {
    permissions: UserPermission[];
    profiles: UserProfile[];
    username: string;
    constructor(options: UserOptions);
    set(options: UserOptions): void;
    unset(): void;
    hasAdminProfile(): boolean;
    hasPermission(permission: string | string[]): boolean;
    hasProfile(profile: string | string[]): boolean;
    /**
     * Checks if the given key or keys are present in the given array of keys.
     * @internal
     * @param keys - The array of keys to check.
     * @param key - The key or keys to check for.
     * @returns True if the key or keys are present in the array of keys.
     */
    private hasKey;
}
/**
 * User DI key.
 * @privateRemarks
 * Marked as internal to stop api-extractor becoming confused cross-linking tokens with the same name.
 * @internal
 */
export declare const User: import("@microsoft/fast-foundation").InterfaceSymbol<User>;
export {};
//# sourceMappingURL=user.d.ts.map