## API Report File for "@genesislcap/foundation-comms"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

/// <reference types="webappsec-credential-management" />

import { BehaviorSubject } from 'rxjs';
import { default as Bowser_2 } from 'bowser';
import type { DTOMapper } from '@genesislcap/foundation-utils';
import { InterfaceSymbol } from '@microsoft/fast-foundation';
import { JSONSchema7 } from 'json-schema';
import { JSONSerializer } from '@genesislcap/foundation-utils';
import { Listener } from '@genesislcap/foundation-utils';
import { Logger } from '@genesislcap/foundation-logger';
import { Observable } from 'rxjs';
import { Observer } from '@genesislcap/foundation-utils';
import { Observer as Observer_2 } from 'rxjs';
import { Subscription as SocketSubscription } from 'rxjs';
import { Subject } from 'rxjs';
import { UUID } from '@genesislcap/foundation-utils';

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Auth" because one of its declarations is marked as @internal
//
// @public
export interface Auth {
    // @internal
    readonly currentUser: User;
    readonly isLoggedIn$?: Observable<boolean>;
    readonly isLoggedIn: boolean;
    isWorking: boolean;
    // @internal
    readonly loggedUserResult: LoginResult;
    login(credentials: AuthInfo): Promise<LoginResult>;
    logout(): Promise<LogoutResult>;
    reAuthFromSession(): Promise<boolean>;
}

// @internal
export const Auth: InterfaceSymbol<Auth>;

// @public
export class AuthError extends Error {
    constructor(sent: Message, received?: Message, message?: string);
    // (undocumented)
    getDetailsError(): string;
    // (undocumented)
    getMessageError(): string;
    // (undocumented)
    hasErrorCode(code: string): boolean;
    // (undocumented)
    hasMFAError(): boolean;
    // (undocumented)
    hasPasswordExpiredError(): boolean;
    // (undocumented)
    isIgnorableError(): boolean;
    // (undocumented)
    received?: Message;
    // (undocumented)
    sent: Message;
}

// @public
export type AuthInfo = BasicAuthInfo | SsoAuthInfo | JwtAuthInfo | RefreshAuthInfo;

// Warning: (ae-internal-missing-underscore) The name "AuthMock" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class AuthMock implements Auth {
    // (undocumented)
    currentUser: User;
    // (undocumented)
    isLoggedIn: boolean;
    // (undocumented)
    isWorking: boolean;
    // (undocumented)
    loggedUserResult: LoginResult;
    // (undocumented)
    login(credentials: AuthInfo): Promise<LoginResult>;
    // (undocumented)
    logout(): Promise<LogoutResult>;
    // (undocumented)
    nextLoginResult: LoginResult;
    // (undocumented)
    nextLogoutResult: LogoutResult;
    // (undocumented)
    nextReAuthResult: boolean;
    // (undocumented)
    reAuthFromSession(): Promise<boolean>;
}

// @public
export enum AuthType {
    // (undocumented)
    BASIC = "BASIC",
    // (undocumented)
    JWT = "JWT",
    // (undocumented)
    REFRESH = "REFRESH",
    // (undocumented)
    SSO = "SSO"
}

// @public
export type BasicAuthInfo = {
    type: AuthType & AuthType.BASIC;
    username: string;
    password: string;
    mfaToken?: string;
};

// @public
export type BasicCredentialsInput = {
    username: string;
    password: string;
};

// @public (undocumented)
export type CommitEvent = CustomEvent<CommitEventDetail>;

// @public (undocumented)
export type CommitEventDetail = {
    eventName: string;
    message: Message;
};

// @public (undocumented)
export const CommitEventType = "connect-commit-event";

// @public
export type CommitParams = {
    DETAILS: any;
    HOSTNAME?: string;
    IGNORE_WARNINGS?: boolean;
    VALIDATE?: boolean;
};

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Connect" because one of its declarations is marked as @internal
//
// @public
export interface Connect {
    commitEvent(eventName: string, params?: CommitParams): Promise<Message>;
    connect(host: string): Promise<boolean>;
    dataLogoff(sourceRef: string): Promise<Message>;
    disconnect(): void;
    getAvailableResources(params?: RequestParams): Promise<Message>;
    getJSONSchema(resourceName: string): Promise<SchemaResponse>;
    getMetadata(resourceName: string, useCache?: boolean): Promise<Metadata>;
    getMoreColumns(sourceRef: string): Promise<Message>;
    getMoreRows(sourceRef: string): Promise<Message>;
    // @internal
    httpMode(): boolean;
    readonly isConnected$?: Observable<boolean>;
    readonly isConnected: boolean;
    // @deprecated
    readonly isConnectedSubject?: BehaviorSubject<boolean>;
    isWorking: boolean;
    request(resourceName: string, params?: RequestParams): Promise<Message>;
    // @internal
    send<T>(message: Message<T | any>, needsHandling?: boolean): Promise<Message | any>;
    // @internal
    setValidSession(valid: boolean): void;
    snapshot(resourceName: string, params?: any): Promise<Message>;
    stream(resourceName: string, onMessage: Function, onError: Function, params?: any): SocketObservable<Message>;
}

// @internal
export const Connect: InterfaceSymbol<Connect>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "ConnectConfig" because one of its declarations is marked as @internal
//
// @public
export interface ConnectConfig {
    connect: SocketConnectOptions;
    reconnect: SocketReconnectOptions;
}

// @internal
export const ConnectConfig: InterfaceSymbol<ConnectConfig>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "ConnectEvents" because one of its declarations is marked as @internal
//
// @public
export interface ConnectEvents {
    addCommitListener(listener: Listener<CommitEvent>): () => void;
    addMetadataListener(listener: Listener<MetadataEvent>): () => void;
    addStreamListener(listener: Listener<StreamEvent>, complete: Listener<StreamCompleteEvent>): () => void;
}

// @internal
export const ConnectEvents: InterfaceSymbol<ConnectEvents>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "ConnectEventsEmitter" because one of its declarations is marked as @internal
//
// @public
export interface ConnectEventsEmitter extends ConnectEvents {
    onCommitEvent(eventName: string, message: Message): void;
    onMetadataEvent(resourceName: string, message: Message<MessageDetails.MetaRequest>, error?: any): void;
    onStreamCompleteEvent(stream: SocketObservable<any>): void;
    onStreamEvent(resourceName: string, message: Message<MessageDetails.DataserverRequest>, stream: SocketObservable<any>, functions: StreamEventFunctions): void;
}

// @internal
export const ConnectEventsEmitter: InterfaceSymbol<ConnectEventsEmitter>;

// @public
export type ConnectionStatus = 'connected' | 'disconnected' | 'busy';

// Warning: (ae-internal-missing-underscore) The name "ConnectMock" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class ConnectMock implements Connect {
    // (undocumented)
    commitEvent(eventName: string, params?: CommitParams): Promise<Message>;
    // (undocumented)
    connect(host: string): Promise<boolean>;
    // (undocumented)
    dataLogoff(sourceRef: string): Promise<Message<any>>;
    // (undocumented)
    disconnect(): void;
    // (undocumented)
    getAvailableResources(params?: RequestParams): Promise<Message>;
    // (undocumented)
    getJSONSchema(resourceName: string): Promise<any>;
    // (undocumented)
    getMetadata(resourceName: string): Promise<Metadata>;
    // (undocumented)
    getMoreColumns(sourceRef: string): Promise<Message<any>>;
    // (undocumented)
    getMoreRows(sourceRef: string): Promise<Message<any>>;
    // (undocumented)
    httpMode(): boolean;
    // (undocumented)
    get isConnected$(): Observable<boolean>;
    // (undocumented)
    isConnected: boolean;
    // (undocumented)
    get isConnectedSubject(): BehaviorSubject<boolean>;
    // (undocumented)
    isWorking: boolean;
    // (undocumented)
    nextJSONSchema: any;
    // (undocumented)
    nextMessage: Message;
    // (undocumented)
    nextMetadata: Metadata;
    // (undocumented)
    request(resourceName: string, params?: RequestParams): Promise<Message>;
    // (undocumented)
    requestParams: RequestParams;
    // (undocumented)
    send<T>(message: Message<any>, needsHandling?: boolean): Promise<any>;
    // (undocumented)
    setValidSession(valid: boolean): void;
    // (undocumented)
    snapshot(resourceName: string, params?: any): Promise<Message>;
    // (undocumented)
    socket: SocketMock;
    // (undocumented)
    stream(resourceName: string, onMessage: Function, onError: Function, params?: any): SocketObservable<Message>;
}

// Warning: (ae-internal-missing-underscore) The name "CoreUserPermissions" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type CoreUserPermissions = 'somePermission' | 'someOtherPermission';

// Warning: (ae-internal-missing-underscore) The name "CoreUserProfiles" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type CoreUserProfiles = 'someProfile' | 'someOtherProfile';

// @public
type CredentialData_2 = PasswordCredentialData & {
    password?: string;
};
export { CredentialData_2 as CredentialData }

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "CredentialManager" because one of its declarations is marked as @internal
//
// @public
export interface CredentialManager {
    createBasicCredentials(inputs: BasicCredentialsInput): BasicAuthInfo;
    createRefreshCredentials(inputs?: RefreshCredentialsInput): RefreshAuthInfo;
    createSSOCredentials(inputs?: SSOCredentialsInput): SsoAuthInfo;
    getCredentials(options?: GetCredentialOptions): Promise<CredentialData_2 | undefined>;
    getCredentialsFromContainer(options?: GetCredentialOptions): Promise<CredentialData_2 | null>;
    getCredentialsFromCookie(): CredentialData_2 | undefined;
    getMFAToken(): string | null;
    getRefreshToken(): string | null;
    getSSOToken(): string | null;
    getUsername(): string | null;
    normaliseLegacyCredentialData(data?: CredentialData_2, cookie?: CredentialData_2): [CredentialData_2 | undefined, boolean];
    preventSilentAccess(): Promise<void>;
    removeAll(): void;
    removeCookie(): void;
    removeMFAToken(): void;
    removeRefreshToken(): void;
    removeSSOToken(): void;
    removeUsername(): void;
    storeCredentials(data: CredentialData_2): Promise<boolean>;
    storeCredentialsInContainer(data: CredentialData_2): Promise<Credential | undefined>;
    storeCredentialsInCookie(data: CredentialData_2): boolean;
    validateBasicCredentials(credentials: BasicAuthInfo): boolean;
    validateRefreshCredentials(credentials: RefreshAuthInfo): boolean;
    validateSSOCredentials(credentials: SsoAuthInfo): boolean;
    validateUserCredentialData(data: CredentialData_2, ensurePassword?: boolean): boolean;
}

// @internal
export const CredentialManager: InterfaceSymbol<CredentialManager>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "CredentialManagerConfig" because one of its declarations is marked as @internal
//
// @public
export interface CredentialManagerConfig {
    // (undocumented)
    cookie: CredentialManagerCookieConfig;
}

// @internal
export const CredentialManagerConfig: InterfaceSymbol<CredentialManagerConfig>;

// @public
export interface CredentialManagerCookieConfig {
    // (undocumented)
    expires: number | Date;
    // (undocumented)
    name: string;
    // (undocumented)
    path: string;
    // (undocumented)
    storePasswords?: boolean;
}

// @public
export const credentialSeparator = ":";

// @public
export function criteriaFiltersToFields(filters: string): Record<string, string>;

// @public
export class CurrentUser implements User {
    // Warning: (ae-forgotten-export) The symbol "UserOptions" needs to be exported by the entry point index.d.ts
    constructor(options: UserOptions);
    // (undocumented)
    hasAdminProfile(): boolean;
    // (undocumented)
    hasPermission(permission: string | string[]): boolean;
    // (undocumented)
    hasProfile(profile: string | string[]): boolean;
    // Warning: (ae-incompatible-release-tags) The symbol "permissions" is marked as @public, but its signature references "UserPermission" which is marked as @internal
    //
    // (undocumented)
    permissions: UserPermission[];
    // Warning: (ae-incompatible-release-tags) The symbol "profiles" is marked as @public, but its signature references "UserProfile" which is marked as @internal
    //
    // (undocumented)
    profiles: UserProfile[];
    // (undocumented)
    set(options: UserOptions): void;
    // (undocumented)
    unset(): void;
    // (undocumented)
    username: string;
}

// @public
export function dataServerResultFilter(result: RawDataServerResult, rowId?: string): FilteredDataServerResult;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Datasource" because one of its declarations is marked as @internal
//
// @public
export interface Datasource {
    addView?(view: Dataview): void;
    clearFilter?(name: string): Promise<void>;
    createItem?(data: any): Promise<string>;
    dataHandler?(data: Array<any>): Array<any>;
    deinit(): any;
    deleteItem?(itemId: string): Promise<void>;
    destroy(): void;
    dropView?(view: Dataview): void;
    fieldMetadata: FieldMetadata[];
    getMetadata?(resourceName: string): Promise<Array<FieldMetadata>>;
    init(options: DatasourceOptions, fetchMeta: boolean): Promise<boolean>;
    initialized: boolean;
    readOnly: boolean;
    resourceType: ResourceType;
    setFilter?(name: string, value: any, type?: string): Promise<void>;
    snapshot(params?: any): any;
    snapshotFiltered(rowId?: string): any;
    stream: SocketObservable<FilteredDataServerResult | RequestServerResult>;
    updateData?(data: Array<any>): Promise<void>;
    updateItem?(itemId: string, data: any): Promise<void>;
    validResourceName(resourceName: string): boolean;
}

// @internal
export const Datasource: InterfaceSymbol<Datasource>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "DatasourceConfig" because one of its declarations is marked as @internal
//
// @public
export interface DatasourceConfig {
    // (undocumented)
    criteriaToFields(filters: string): Record<string, string>;
    // (undocumented)
    dataServerResultFilter(result: RawDataServerResult, rowId?: string): FilteredDataServerResult;
    // (undocumented)
    options: DatasourceOptions;
}

// @internal
export const DatasourceConfig: InterfaceSymbol<DatasourceConfig>;

// @public
export class DatasourceDefaults {
    // (undocumented)
    static readonly DATASERVER_ROW_ID = "ROW_REF";
    // (undocumented)
    static readonly MAX_ROWS_250 = 250;
    // (undocumented)
    static readonly MAX_VIEW_1000 = 1000;
    // (undocumented)
    static readonly REQ_REP_POLLING_INTERVAL_MS = 10000;
    // (undocumented)
    static readonly REQUEST_SERVER_ROW_ID = "RECORD_ID";
}

// Warning: (ae-internal-missing-underscore) The name "DatasourceMock" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class DatasourceMock implements Datasource {
    // (undocumented)
    addView?(view: Dataview): void;
    // (undocumented)
    clearFilter?(name: string): Promise<void>;
    // (undocumented)
    createItem?(data: any): Promise<string>;
    // (undocumented)
    dataHandler?(data: any[]): any[];
    // (undocumented)
    deinit(): void;
    // (undocumented)
    deleteItem?(itemId: string): Promise<void>;
    // (undocumented)
    destroy(): void;
    // (undocumented)
    dropView?(view: Dataview): void;
    // (undocumented)
    fieldMetadata: FieldMetadata[];
    // (undocumented)
    getMetadata?(resourceName: string): Promise<FieldMetadata[]>;
    // (undocumented)
    init(options: DatasourceOptions, fetchMeta: boolean): Promise<boolean>;
    // (undocumented)
    initialized: boolean;
    // (undocumented)
    readOnly: boolean;
    // (undocumented)
    resourceType: ResourceType;
    // (undocumented)
    setFilter?(name: string, value: any, type?: string): Promise<void>;
    // (undocumented)
    snapshot(params?: any): void;
    // (undocumented)
    snapshotFiltered(rowId?: string): void;
    // (undocumented)
    stream: SocketObservable<FilteredDataServerResult | RequestServerResult>;
    // (undocumented)
    updateData?(data: any[]): Promise<void>;
    // (undocumented)
    updateItem?(itemId: string, data: any): Promise<void>;
    // (undocumented)
    validResourceName(resourceName: string): boolean;
}

// @public
export interface DatasourceOptions {
    criteria?: string;
    disablePolling?: boolean;
    fields?: string;
    isSnapshot?: boolean;
    maxRows?: number;
    maxView?: number;
    movingView?: boolean;
    orderBy?: string;
    pollingInterval?: number;
    request?: any;
    resourceName?: string;
    reverse?: boolean;
}

// @public
export interface DataUpdate {
    // (undocumented)
    add?: Array<any>;
    // (undocumented)
    drop?: Array<any>;
    // (undocumented)
    modify?: Array<any>;
}

// @public
export interface Dataview {
    columnsMetadata?: FieldMetadata[];
    data: any[];
    hideSearch?: boolean;
    update?: (data: DataUpdate) => Promise<void>;
}

// @public
export class DefaultAuth implements Auth {
    constructor(session: Session, connect: Connect, messageBuilder: MessageBuilder, credentialManager: CredentialManager);
    // (undocumented)
    currentUser: User;
    // (undocumented)
    get isLoggedIn$(): Observable<boolean>;
    // (undocumented)
    get isLoggedIn(): boolean;
    // (undocumented)
    isWorking: boolean;
    // (undocumented)
    loggedUserResult: LoginResult;
    // (undocumented)
    login(credentials: AuthInfo): Promise<LoginResult>;
    // (undocumented)
    logout(): Promise<LogoutResult>;
    // (undocumented)
    reAuthFromSession(): Promise<boolean>;
}

// @public
export class DefaultConnect implements Connect {
    constructor(socket: Socket, messageBuilder: MessageBuilder, metaCache: MetaCache, events: ConnectEventsEmitter, config?: ConnectConfig);
    // (undocumented)
    commitEvent(eventName: string, params?: CommitParams): Promise<Message>;
    // (undocumented)
    connect(host: string): Promise<boolean>;
    // (undocumented)
    dataLogoff(streamSourceRef: string): Promise<Message>;
    // (undocumented)
    disconnect(): void;
    // (undocumented)
    getAvailableResources(params?: any): Promise<Message>;
    // (undocumented)
    getJSONSchema(resourceName: string, useCache?: boolean): Promise<SchemaResponse>;
    // (undocumented)
    getMetadata(resourceName: string, useCache?: boolean): Promise<Metadata>;
    // (undocumented)
    getMoreColumns(sourceRef: string): Promise<Message>;
    // (undocumented)
    getMoreRows(sourceRef: string): Promise<Message>;
    // (undocumented)
    httpMode(): boolean;
    // (undocumented)
    get isConnected$(): Observable<boolean>;
    // (undocumented)
    get isConnected(): boolean;
    // (undocumented)
    get isConnectedSubject(): BehaviorSubject<boolean>;
    // (undocumented)
    isWorking: boolean;
    // (undocumented)
    request(resourceName: string, params?: RequestParams): Promise<Message>;
    // (undocumented)
    send<T>(message: Message<any>, needsHandling?: boolean): Promise<any>;
    // (undocumented)
    setValidSession(valid: boolean): void;
    // (undocumented)
    snapshot(resourceName: string, params?: any): Promise<Message>;
    // (undocumented)
    socket: Socket;
    // (undocumented)
    stream(resourceName: string, onMessage: Function, onError: Function, params?: any): SocketObservable<Message>;
}

// @public
export const defaultConnectConfig: ConnectConfig;

// @public
export class DefaultConnectEvents implements ConnectEventsEmitter {
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "ConnectEvents" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    addCommitListener(listener: Listener<CommitEvent>): () => void;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "ConnectEvents" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    addMetadataListener(listener: Listener<MetadataEvent>): () => void;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "ConnectEvents" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    addStreamListener(listener: Listener<StreamEvent>, complete: Listener<StreamCompleteEvent>): () => void;
    // @internal (undocumented)
    protected commitListeners: Observer<CommitEvent>;
    // @internal (undocumented)
    protected metadataListeners: Observer<MetadataEvent>;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "ConnectEventsEmitter" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    onCommitEvent(eventName: string, message: Message): void;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "ConnectEventsEmitter" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    onMetadataEvent(resourceName: string, message: Message<MessageDetails.MetaRequest>, error?: any): void;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "ConnectEventsEmitter" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    onStreamCompleteEvent(stream: SocketObservable<any>): void;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "ConnectEventsEmitter" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    onStreamEvent(resourceName: string, message: Message<MessageDetails.DataserverRequest>, stream: SocketObservable<any>, functions: StreamEventFunctions): void;
    // @internal (undocumented)
    protected streamCompleteListeners: Observer<StreamCompleteEvent>;
    // @internal (undocumented)
    protected streamListeners: Observer<StreamEvent>;
}

// @public
export class DefaultCredentialManager implements CredentialManager {
    constructor(session: Session, config?: CredentialManagerConfig);
    // (undocumented)
    createBasicCredentials(inputs: BasicCredentialsInput): BasicAuthInfo;
    // (undocumented)
    createRefreshCredentials(inputs?: RefreshCredentialsInput): RefreshAuthInfo;
    // (undocumented)
    createSSOCredentials(inputs?: SSOCredentialsInput): SsoAuthInfo;
    // (undocumented)
    getCredentials(options?: GetCredentialOptions): Promise<CredentialData_2 | undefined>;
    // (undocumented)
    getCredentialsFromContainer(options?: CredentialRequestOptions): Promise<CredentialData_2 | null>;
    // (undocumented)
    getCredentialsFromCookie(): CredentialData_2 | undefined;
    // (undocumented)
    getMFAToken(): string;
    // (undocumented)
    getRefreshToken(): string;
    // (undocumented)
    getSSOToken(): string;
    // (undocumented)
    getUsername(): string;
    // (undocumented)
    normaliseLegacyCredentialData(data?: CredentialData_2, cookie?: CredentialData_2): [CredentialData_2 | undefined, boolean];
    // (undocumented)
    preventSilentAccess(): Promise<void>;
    // (undocumented)
    removeAll(): void;
    // (undocumented)
    removeCookie(): void;
    // (undocumented)
    removeMFAToken(): void;
    // (undocumented)
    removeRefreshToken(): void;
    // (undocumented)
    removeSSOToken(): void;
    // (undocumented)
    removeUsername(): void;
    // (undocumented)
    storeCredentials(data: CredentialData_2): Promise<boolean>;
    // (undocumented)
    storeCredentialsInContainer(data: CredentialData_2): Promise<Credential | undefined>;
    // (undocumented)
    storeCredentialsInCookie(data: CredentialData_2): boolean;
    // (undocumented)
    validateBasicCredentials(credentials: BasicAuthInfo): boolean;
    // (undocumented)
    validateRefreshCredentials(credentials: RefreshAuthInfo): boolean;
    // (undocumented)
    validateSSOCredentials(credentials: SsoAuthInfo): boolean;
    // (undocumented)
    validateUserCredentialData(data: CredentialData_2, ensurePassword?: boolean): boolean;
}

// @public
export const defaultCredentialManagerConfig: CredentialManagerConfig;

// @public
export const defaultCredentialRequestOptions: GetCredentialOptions;

// @public
export class DefaultDatasource implements Datasource {
    constructor(connect: Connect, auth: Auth, config?: DatasourceConfig);
    // (undocumented)
    protected auth: Auth;
    // (undocumented)
    protected availableIndexes: IndexDetail[];
    // (undocumented)
    protected config: DatasourceConfig;
    // (undocumented)
    protected connect: Connect;
    // (undocumented)
    deinit(): void;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "Datasource" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    destroy(): void;
    // (undocumented)
    fieldMetadata: FieldMetadata[];
    // (undocumented)
    init(options: DatasourceOptions, fetchMeta?: boolean): Promise<boolean>;
    // (undocumented)
    initialized: boolean;
    // (undocumented)
    protected options: DatasourceOptions;
    // (undocumented)
    protected originalFieldDef: MetadataDetail[];
    // (undocumented)
    get params(): any;
    // (undocumented)
    readOnly: boolean;
    // (undocumented)
    protected requestFields: MetadataDetail[];
    // (undocumented)
    resourceType: ResourceType;
    // (undocumented)
    snapshot(): Promise<Message>;
    // (undocumented)
    snapshotFiltered(rowId?: string): Promise<any[]>;
    // (undocumented)
    get stream(): SocketObservable<FilteredDataServerResult | RequestServerResult>;
    // (undocumented)
    protected _stream: SocketObservable<FilteredDataServerResult | RequestServerResult>;
    // (undocumented)
    validResourceName(resourceName: string): boolean;
}

// @public
export const defaultDatasourceConfig: DatasourceConfig;

// @alpha
export class DefaultEntityDatasource<TDTO, TEntity> extends DefaultDatasource implements EntityDatasource<TDTO, TEntity> {
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "EntityDatasource" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    get cache(): TEntity[];
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "EntityDatasource" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    disconnect: () => void;
    // (undocumented)
    protected entityCache: TEntity[];
    // (undocumented)
    protected entityMap: Map<string, TEntity>;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "EntityDatasource" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    initialize: (init: EntityDatasourceInit<TDTO, TEntity>) => Promise<boolean>;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "EntityDatasource" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    initialized: boolean;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "EntityDatasource" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    get isEmpty(): boolean;
    // (undocumented)
    protected mapper: DTOMapper<TDTO, TEntity>;
    // (undocumented)
    protected processRowDataUpdate(rowData: RowData[], inserting?: boolean): void;
    // (undocumented)
    protected rowId: string;
    // (undocumented)
    protected sourceRef: string;
    // (undocumented)
    protected subscription: SocketSubscription;
    // (undocumented)
    protected subscriptionLoggedOff: boolean;
    // (undocumented)
    protected updateCache(result: FilteredDataServerResult): void;
}

// @public
export class DefaultFoundationAnalytics implements FoundationAnalytics {
    constructor(config: {
        app: 'foundation-app';
        debug: true;
    });
    trackEvent(eventName: FoundationAnalyticsEventType.controlClicked, payload: FoundationAnalyticsEvent.ControlClicked): void;
    // (undocumented)
    trackEvent(eventName: FoundationAnalyticsEventType.routeChanged, payload: FoundationAnalyticsEvent.RouteChanged): void;
}

// @public
export class DefaultHttp implements Http {
    constructor(serializer: JSONSerializer);
    // (undocumented)
    get<T>(url: string, requestInit: HttpRequestInit): Promise<T>;
    // (undocumented)
    post<T>(url: string, requestInit: HttpRequestInit): Promise<T>;
}

// @public
export class DefaultHttpConnect implements Connect {
    constructor(http: Http, messageBuilder: MessageBuilder, session: Session, metaCache: MetaCache, serializer: JSONSerializer, config?: HttpConnectConfig);
    // (undocumented)
    commitEvent(eventName: string, params?: CommitParams): Promise<Message>;
    // (undocumented)
    connect(host: string): Promise<boolean>;
    // (undocumented)
    dataLogoff(streamSourceRef: string): Promise<Message>;
    // (undocumented)
    disconnect(): void;
    // (undocumented)
    getAvailableResources(params?: any): Promise<Message>;
    // (undocumented)
    getJSONSchema(resourceName: string): Promise<SchemaResponse>;
    // (undocumented)
    getMetadata(resourceName: string, useCache?: boolean): Promise<Metadata>;
    // (undocumented)
    getMoreColumns(sourceRef: string): Promise<Message>;
    // (undocumented)
    getMoreRows(sourceRef: string): Promise<Message>;
    // (undocumented)
    host: string;
    // (undocumented)
    http: Http;
    // (undocumented)
    httpMode(): boolean;
    // (undocumented)
    isConnected$: Observable<boolean>;
    // (undocumented)
    get isConnected(): boolean;
    set isConnected(value: boolean);
    // (undocumented)
    isConnectedSubject: BehaviorSubject<boolean>;
    // (undocumented)
    isWorking: boolean;
    // (undocumented)
    request(resourceName: string, params?: RequestParams): Promise<Message>;
    // (undocumented)
    send<T>(message: Message<any>, needsHandling?: boolean): Promise<any>;
    // (undocumented)
    setValidSession(valid: boolean): void;
    // (undocumented)
    snapshot(resourceName: string, params?: any): Promise<Message>;
    // (undocumented)
    stream(resourceName: string, onMessage: Function, onError: Function, params?: any): SocketObservable<Message>;
}

// @public
export const defaultHttpConnectConfig: HttpConnectConfig;

// @alpha
export class DefaultKVStorage implements KVStorage {
    constructor(connect: Connect, auth: Auth, kvStorageConfig?: KVStorageConfig);
    delete(keys: string[]): Promise<true | KVEventFailureResponse>;
    get<T = KVValue>(key?: string): Promise<KeyValueTransfer<T>[]>;
    list(): Promise<string[]>;
    put(kvs: KeyValue<KVValue>[]): Promise<true | KVEventFailureResponse>;
}

// @alpha
export const defaultKVStorageConfig: KVStorageConfig;

// @public
export class DefaultMessageBuilder implements MessageBuilder {
    constructor(session: Session, uuid: UUID);
    // (undocumented)
    createChangePasswordMessage(username: string, oldPassword: string, newPassword: string): Message<MessageDetails.ChangePassword>;
    // (undocumented)
    createCommitMessage<T = any>(eventName: string, params?: CommitParams): Message<T>;
    // (undocumented)
    createDataLogoffMessage<T = any>(sourceRef: string): Message<T>;
    // (undocumented)
    createDataLogonMessage(resourceName: string, params?: any): Message<MessageDetails.DataserverRequest>;
    // (undocumented)
    createForgotPasswordMessage(username: string, returnUrl: string, requester?: string): Message<MessageDetails.ForgotPassword>;
    // (undocumented)
    createForgotPasswordTokenMessage(username: string, resetToken: string, newPassword: string, requester?: string): Message<MessageDetails.ForgotPasswordToken>;
    // (undocumented)
    createHTTPHeadersFromMessage(message: Message, contentType?: string): HeadersInit;
    // (undocumented)
    createLoginMessage(credentials: AuthInfo): Message<MessageDetails.Login>;
    // (undocumented)
    createLogoutMessage(loginResult?: LoginResult): Message;
    // (undocumented)
    createMetaRequestMessage(resourceName: string, messageType?: EventMessageType): Message<MessageDetails.MetaRequest>;
    // (undocumented)
    createMoreColumnsMessage(sourceRef: string): Message;
    // (undocumented)
    createMoreRowsMessage(sourceRef: string): Message;
    // (undocumented)
    createRefreshTokenMessage(): Message<MessageDetails.RefreshToken>;
    // (undocumented)
    createRequestMessage<T = any>(resourceName: string, params?: RequestParams): Message<T>;
    // (undocumented)
    createResourcesMessage<T = any>(params?: RequestParams): Message<T>;
}

// @public
export class DefaultMetaCache implements MetaCache {
    // (undocumented)
    cachedJsonSchema: Map<string, SchemaResponse>;
    // (undocumented)
    cachedMetadata: Map<string, Metadata>;
    // (undocumented)
    getJsonSchemaFor(resourceName: string): SchemaResponse;
    // (undocumented)
    getMetadataFor(resourceName: string): Metadata;
    // (undocumented)
    hasJsonSchemaFor(resourceName: string): boolean;
    // (undocumented)
    hasMetadataFor(resourceName: string): boolean;
    // (undocumented)
    setJsonSchemaFor(resourceName: string, schemaResponse: SchemaResponse): void;
    // (undocumented)
    setMetadataFor(resourceName: string, metadata: Metadata): void;
}

// @public
export class DefaultNetworkMonitor implements NetworkMonitor {
    // @internal (undocumented)
    protected addListeners(): void;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "NetworkMonitor" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    addResource(resource: MonitoredResource, metadata: MonitoredResourceMetadata): void;
    // @internal
    protected config: NetworkMonitorConfig;
    // @internal (undocumented)
    protected connectEvents: ConnectEvents;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "NetworkMonitor" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    create(): void;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "NetworkMonitor" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    destroy(): void;
    // @internal (undocumented)
    protected getFormattedTimestamp(milliseconds: number): string;
    // @internal (undocumented)
    protected getNextTimestamp(): number;
    // @internal (undocumented)
    protected getNowTimestamp(): number;
    // @internal (undocumented)
    protected internalId: ReturnType<typeof setInterval>;
    // @internal (undocumented)
    protected isOnlineCheck(): Promise<boolean>;
    // @internal (undocumented)
    protected isRunningChecks: boolean;
    // @internal (undocumented)
    protected normaliseEventDetail(detail: Partial<SystemHealthStatus>): SystemHealthStatus;
    // @internal (undocumented)
    protected normaliseResourceHealth(health: ResourceHealth, isOnline?: boolean): ResourceHealth;
    // @internal (undocumented)
    protected normaliseSerializedSocketStatus(socketStatus: SerializedSocketStatus, isOnline?: boolean): SerializedSocketStatus;
    // @internal (undocumented)
    protected removeListeners(): void;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "NetworkMonitor" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    removeResource(resource: MonitoredResource): void;
    // @internal (undocumented)
    protected reportStabilityToGenesis(detail: Partial<SystemHealthStatus>): Promise<boolean>;
    // @internal (undocumented)
    protected reportSystemHealth(detail: Partial<SystemHealthStatus>): void;
    // @internal (undocumented)
    protected resources: Map<MonitoredResource, MonitoredResourceMetadata>;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "NetworkMonitor" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    runAllChecks: (source?: unknown, force?: boolean) => Promise<void>;
    // @internal (undocumented)
    protected socketStatus: SocketStatus;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "NetworkMonitor" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    status: SystemHealthStatus;
    // @internal (undocumented)
    protected synchroniseCheckInterval(): void;
    // @internal (undocumented)
    protected unsubscribableObservers: any[];
    // @internal (undocumented)
    protected user: User;
}

// @public
export const defaultNetworkMonitorConfig: NetworkMonitorConfig;

// @public
export class DefaultSession implements Session {
    // (undocumented)
    captureReturnUrl(): void;
    // (undocumented)
    deleteUserFromSessionStorage(): void;
    // (undocumented)
    getItem(key: string | UserInfoKeys, storage: StorageType): string;
    // (undocumented)
    getLocalStorageItem(key: string | UserInfoKeys): string;
    // (undocumented)
    getSessionStorageItem(key: string | UserInfoKeys): string;
    // (undocumented)
    removeItem(key: string | UserInfoKeys, storage: StorageType): void;
    // (undocumented)
    removeLocalStorageItem(key: string | UserInfoKeys): void;
    // (undocumented)
    removeSessionStorageItem(key: string | UserInfoKeys): void;
    // (undocumented)
    returnUrl: string;
    // (undocumented)
    setAuthResult(result: Message): void;
    // Warning: (ae-forgotten-export) The symbol "UserInfoKeys" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    setItem(key: string | UserInfoKeys, value: string, storage: StorageType): void;
    // (undocumented)
    setLocalStorageItem(key: string | UserInfoKeys, value: string): void;
    // (undocumented)
    setSessionStorageItem(key: string | UserInfoKeys, value: string): void;
    // (undocumented)
    setStorageKeyPrefix(prefix: string): void;
}

// @public
export class DefaultSocket implements Socket {
    constructor(messageBuilder: MessageBuilder, session: Session, serializer: JSONSerializer, uuid: UUID, status: SocketStatus);
    // (undocumented)
    connect(host: string, connectOptions?: SocketConnectOptions, reconnectOptions?: SocketReconnectOptions): Promise<boolean>;
    // (undocumented)
    get hasValidSession(): boolean;
    set hasValidSession(value: boolean);
    // (undocumented)
    get isConfigured(): boolean;
    // (undocumented)
    get isConnected(): boolean;
    // (undocumented)
    get isConnectedSubject(): BehaviorSubject<boolean>;
    // (undocumented)
    get isConnecting(): boolean;
    // (undocumented)
    get isDisconnected(): boolean;
    // (undocumented)
    get isDisconnectedByServer(): boolean;
    // (undocumented)
    get isReconnecting(): boolean;
    // (undocumented)
    reset(): void;
    // (undocumented)
    send<T>(message: Message<T | any>, needsHandling?: boolean): Promise<Message | any>;
    // (undocumented)
    sendForStream<T>(message: Message<T | any>, onMessage: Function, onError: Function, onComplete?: Function): Observable<Message>;
    // (undocumented)
    socketMessages: () => SocketSubject<Message>;
}

// @public
export class DefaultSocketStatus implements SocketStatus {
    // (undocumented)
    closedClean: any;
    // (undocumented)
    closedCode: any;
    // (undocumented)
    closedReason: any;
    // (undocumented)
    hasValidSession: boolean;
    // (undocumented)
    isConfigured: boolean;
    // (undocumented)
    isConnected: boolean;
    // (undocumented)
    protected isConnectedChanged(): void;
    // (undocumented)
    isConnectedSubject: BehaviorSubject<boolean>;
    // (undocumented)
    isConnecting: boolean;
    // (undocumented)
    get isDisconnected(): boolean;
    // (undocumented)
    get isDisconnectedByServer(): boolean;
    // (undocumented)
    isReconnecting: boolean;
    // (undocumented)
    protected isReconnectingChanged(): void;
    // (undocumented)
    onClose(event: CloseEvent): void;
    // (undocumented)
    reconnectionLimitReached: boolean;
    // (undocumented)
    protected resetClosedState(): void;
    // (undocumented)
    serialize(): SerializedSocketStatus;
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "EntityDatasource" because one of its declarations is marked as @internal
//
// @alpha
export interface EntityDatasource<TDTO, TEntity> {
    // (undocumented)
    readonly cache: TEntity[];
    // (undocumented)
    disconnect(): void;
    // (undocumented)
    initialize(init: EntityDatasourceInit<TDTO, TEntity>): Promise<boolean>;
    // (undocumented)
    readonly initialized: boolean;
    // (undocumented)
    readonly isEmpty: boolean;
}

// @internal
export const EntityDatasource: InterfaceSymbol<EntityDatasource<any, any>>;

// @alpha
export interface EntityDatasourceInit<TDTO, TEntity> {
    // (undocumented)
    fetchMeta?: boolean;
    // (undocumented)
    mapper: DTOMapper<TDTO, TEntity>;
    // (undocumented)
    options: Omit<DatasourceOptions, 'isSnapshot'>;
}

// @public
export enum EventMessageType {
    // (undocumented)
    DATA_LOGOFF = "DATA_LOGOFF",
    // (undocumented)
    DATA_LOGON = "DATA_LOGON",
    // (undocumented)
    EVENT_CHANGE_USER_PASSWORD = "EVENT_CHANGE_USER_PASSWORD",
    // (undocumented)
    EVENT_LOGIN_AUTH = "EVENT_LOGIN_AUTH",
    // (undocumented)
    EVENT_LOGIN_AUTH_ACK = "EVENT_LOGIN_AUTH_ACK",
    // (undocumented)
    EVENT_LOGIN_AUTH_NACK = "EVENT_LOGIN_AUTH_NACK",
    // (undocumented)
    EVENT_LOGOUT = "EVENT_LOGOUT",
    // (undocumented)
    EVENT_PASSWORD_RESET_ACTION = "EVENT_PASSWORD_RESET_ACTION",
    // (undocumented)
    EVENT_SELF_SERVICE_PASSWORD_RESET = "EVENT_SELF_SERVICE_PASSWORD_RESET",
    // (undocumented)
    JSON_SCHEMA_REQUEST = "JSON_SCHEMA_REQUEST",
    // (undocumented)
    META_REQUEST = "META_REQUEST",
    // (undocumented)
    RESOURCES_REQUEST = "RESOURCES_REQUEST"
}

// @public
export const exponentialScheduler: SocketReconnectScheduler;

// @public
export const extractFieldDefinitions: (metadata: Metadata) => MetadataDetail[];

// @public
export type FieldMetadata = {
    name: string;
    displayName?: string;
    type: FieldTypeEnum;
    enumOptions?: Array<any>;
    enumMultiple?: boolean;
    required?: boolean;
    readOnly?: boolean;
    component?: string;
};

// @public
export enum FieldTypeEnum {
    // (undocumented)
    BOOLEAN = "BOOLEAN",
    // (undocumented)
    CUSTOM = "CUSTOM",
    // (undocumented)
    DATE = "DATE",
    // (undocumented)
    DATETIME = "DATETIME",
    // (undocumented)
    ENUM = "ENUM",
    // (undocumented)
    NUMBER = "NUMBER",
    // (undocumented)
    STRING = "STRING"
}

// @public
export type FilteredDataServerResult = {
    inserts?: RowData[];
    deletes?: RowData[];
    updates?: RowData[];
    SOURCE_REF?: string;
};

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FoundationAnalytics" because one of its declarations is marked as @internal
//
// @public
export interface FoundationAnalytics {
    trackEvent(eventName: FoundationAnalyticsEventType.controlClicked, payload: FoundationAnalyticsEvent.ControlClicked): void;
    trackEvent(eventName: FoundationAnalyticsEventType.routeChanged, payload: FoundationAnalyticsEvent.RouteChanged): void;
    trackEvent(eventName: FoundationAnalyticsEventType, payload: {}): void;
}

// @internal
export const FoundationAnalytics: InterfaceSymbol<FoundationAnalytics>;

// @public
export namespace FoundationAnalyticsEvent {
    export interface ControlClicked {
        // (undocumented)
        name: string;
    }
    export interface RouteChanged {
        // (undocumented)
        path: string;
        // (undocumented)
        referrer?: string;
    }
}

// @public
export enum FoundationAnalyticsEventType {
    // (undocumented)
    controlClicked = "controlClicked",
    // (undocumented)
    routeChanged = "routeChanged"
}

// @public
export type GenesisConnectEvents = 'stream' | 'commit';

// @public
export function getConnect(): Connect;

// @public
export type GetCredentialOptions = CredentialRequestOptions & {};

// @public
export function getDatasource(): Datasource;

// @public
export function getNetworkMonitor(): NetworkMonitor;

// @public
export function getSocket(): Socket;

// @public
export function getSocketStatus(): SocketStatus;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Http" because one of its declarations is marked as @internal
//
// @public
export interface Http {
    // (undocumented)
    get<T = any>(url: string, requestInit: HttpRequestInit): Promise<T>;
    // (undocumented)
    post<T = any>(url: string, requestInit: HttpRequestInit): Promise<T>;
}

// @internal
export const Http: InterfaceSymbol<Http>;

// Warning: (ae-internal-missing-underscore) The name "HttpConnect" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export const HttpConnect: InterfaceSymbol<Connect>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "HttpConnectConfig" because one of its declarations is marked as @internal
//
// @public
export interface HttpConnectConfig {
    polling: HttpPollingConfig;
}

// @internal
export const HttpConnectConfig: InterfaceSymbol<HttpConnectConfig>;

// @public
export interface HttpPollingConfig {
    POLLING_FREQUENCY?: number;
    POLLING_INTERVAL_MAP?: {
        [resource: string]: number;
    };
    POLLING_MAP?: {
        [key: string]: PollingConfiguration;
    };
}

// @public
export interface HttpRequestInit extends RequestInit {
    serializer?: JSONSerializer;
}

// @public
export type IndexDetail = {
    NAME: string;
    FIELDS: string;
};

// @public
export const isWebSocketExpression: RegExp;

// @public
export interface JsonSchemaCache {
    // (undocumented)
    cachedJsonSchema: Map<string, SchemaResponse>;
    // (undocumented)
    getJsonSchemaFor(resourceName: string): SchemaResponse;
    // (undocumented)
    hasJsonSchemaFor(resourceName: string): boolean;
    // (undocumented)
    setJsonSchemaFor(resourceName: string, schemaResponse: SchemaResponse): any;
}

// @public
export type JwtAuthInfo = {
    type: AuthType & AuthType.JWT;
    jwt: string;
    domain: string;
};

// @alpha
export interface KeyValue<T = KVValue> {
    base64?: boolean;
    expiration?: number;
    key: string;
    metadata?: {
        [key: string]: unknown;
    };
    value?: T;
}

// @alpha
export interface KeyValueTransfer<T> {
    // (undocumented)
    deserialize?(value: unknown): Promise<T>;
    // (undocumented)
    kv: KeyValue<T>;
    // (undocumented)
    serialize?(value: unknown): unknown;
}

// @alpha
export type KVEventFailureResponse = {
    ERROR?: MessageError[];
    WARNING: any[];
};

// @alpha
export enum KVEventMessageType {
    // (undocumented)
    EVENT_KEY_VALUE_DELETE = "EVENT_KEY_VALUE_DELETE",
    // (undocumented)
    EVENT_KEY_VALUE_PUT = "EVENT_KEY_VALUE_PUT"
}

// @alpha
export enum KVMessageType {
    // (undocumented)
    REQ_KEY_VALUE_LIST = "REQ_KEY_VALUE_LIST",
    // (undocumented)
    REQ_KEY_VALUE_READ = "REQ_KEY_VALUE_READ"
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "KVStorage" because one of its declarations is marked as @internal
//
// @alpha
export interface KVStorage {
    // (undocumented)
    delete(keys: string[]): Promise<true | KVEventFailureResponse>;
    // (undocumented)
    get<T = KVValue>(key?: string): Promise<KeyValueTransfer<T>[]>;
    // (undocumented)
    list(): Promise<string[]>;
    // (undocumented)
    put(kvs: KeyValue<KVValue>[]): Promise<true | KVEventFailureResponse>;
}

// @internal
export const KVStorage: InterfaceSymbol<KVStorage>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "KVStorageConfig" because one of its declarations is marked as @internal
//
// @alpha
export interface KVStorageConfig {
    account?: string;
    authEmail?: string;
    authKey?: string;
    namespace?: string;
}

// @internal
export const KVStorageConfig: InterfaceSymbol<KVStorageConfig>;

// @alpha
export type KVValue = string | ArrayBuffer;

// @public
export const linearScheduler: SocketReconnectScheduler;

// @public
export const logger: Logger;

// @public
export type LoginResult = {
    authToken: string;
    refreshToken: string;
    username: string;
    profiles: string[];
    permissions: string[];
    sessionId: string;
};

// @public
export interface LogoutResult {
    error?: string;
    success: boolean;
}

// @public
export const MAX_RECONNECT_ATTEMPTS = 10;

// @public
export type Message<T = void | any> = {
    REPLY?: any[];
    CODE?: MessageCode | string;
    DETAILS?: T;
    LOGGED_OUT?: boolean;
    ERROR?: MessageError[];
    MESSAGE_TYPE?: MessageType | EventMessageType | string;
    PERMISSION?: string[];
    PROFILE?: string[];
    RESOURCES?: any[];
    REFRESH_AUTH_TOKEN?: string;
    ROW?: any[];
    ROWS_COUNT?: number;
    SEQUENCE_ID?: number;
    SERVICE_NAME?: string;
    SESSION_AUTH_TOKEN?: string;
    SESSION_ID?: string;
    SOURCE_REF?: string;
    USER_NAME?: string;
    WARNING?: any[];
};

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "MessageBuilder" because one of its declarations is marked as @internal
//
// @public
export interface MessageBuilder {
    createChangePasswordMessage(username: string, oldPassword: string, newPassword: string): Message<MessageDetails.ChangePassword>;
    createCommitMessage<T = any>(eventName: string, params?: CommitParams): Message<T>;
    createDataLogoffMessage<T = any>(sourceRef: string): Message<T>;
    createDataLogonMessage(resourceName: string, params?: any): Message<MessageDetails.DataserverRequest>;
    createForgotPasswordMessage(username: string, returnUrl: string, requester?: string): Message<MessageDetails.ForgotPassword>;
    createForgotPasswordTokenMessage(username: string, resetToken: string, newPassword: string, requester?: string): Message<MessageDetails.ForgotPasswordToken>;
    createHTTPHeadersFromMessage(message: Message, contentType?: string): HeadersInit;
    createLoginMessage(credentials: AuthInfo): Message<MessageDetails.Login>;
    createLogoutMessage(loginResult?: LoginResult): Message;
    createMetaRequestMessage(resourceName: string, messageType?: EventMessageType): Message<MessageDetails.MetaRequest>;
    createMoreColumnsMessage(sourceRef: string): Message;
    createMoreRowsMessage(sourceRef: string): Message;
    createRefreshTokenMessage(): Message<MessageDetails.RefreshToken>;
    createRequestMessage<T = any>(resourceName: string, params?: any): Message<T>;
    createResourcesMessage<T = any>(params?: any): Message<T>;
}

// @internal
export const MessageBuilder: InterfaceSymbol<MessageBuilder>;

// @public
export enum MessageCode {
    // (undocumented)
    SESSION_NOT_FOUND = "SESSION_NOT_FOUND",
    // (undocumented)
    UNKNOWN_MESSAGE_TYPE = "UNKNOWN_MESSAGE_TYPE"
}

// @public
export namespace MessageDetails {
    export type ChangePassword = {
        OLD_PASSWORD: string;
        NEW_PASSWORD: string;
    };
    export type DataserverRequest = {
        DATASOURCE_NAME: string;
    };
    export type Error = {
        ERROR: string;
    };
    export type ExpirePassword = {
        USER_NAME: string;
        PASSWORD: string;
    };
    export type ForgotPassword = {
        USER_NAME: string;
        RETURN_URL: string;
    };
    export type ForgotPasswordToken = {
        USER_NAME: string;
        RESET_TOKEN: string;
        NEW_PASSWORD: string;
    };
    export type LoggedInSystemInfo = {
        DAYS_TO_PASSWORD_EXPIRY: number;
        FAILED_LOGIN_ATTEMPTS: number;
        HEARTBEAT_INTERVAL_SECS: number;
        LAST_LOGIN_DATETIME: number;
        NOTIFY_EXPIRY?: boolean;
        PRODUCT?: any[];
        SYSTEM?: any;
    };
    export type Login = LoginBasic | LoginSSO | LoginJWT;
    export type LoginBasic = {
        USER_NAME: string;
        PASSWORD: string;
    };
    export type LoginJWT = {
        JWT: string;
        DOMAIN: string;
    };
    export type LoginSSO = {
        SSO_TOKEN: string;
    };
    export type MetaRequest = {
        FEATURE: string;
    };
    export type MoreRows = {
        SOURCE_REF: string;
    };
    export type RefreshToken = {
        REFRESH_AUTH_TOKEN: string;
        MFA_CODE?: string;
    };
    export type ResetPassword = {
        USER_NAME: string;
    };
    export type UpdateColumns = {
        SOURCE_REF: string;
        ADD_COLUMNS: string;
        DROP_COLUMNS: string;
    };
}

// @public
export type MessageError = {
    CODE: MessageCode | string;
    STATUS_CODE?: string;
    TEXT: string;
};

// @public
export const messageHasErrorCode: (message: Message, code: string | number) => boolean;

// @public
export const messageOrThrow: (message: Message) => Message<any>;

// @public
export enum MessageType {
    // (undocumented)
    HEARTBEAT_PING = "HEARTBEAT_PING",
    // (undocumented)
    HEARTBEAT_PONG = "HEARTBEAT_PONG",
    // (undocumented)
    LOGOFF_ACK = "LOGOFF_ACK",
    // (undocumented)
    LOGOFF_NACK = "LOGOFF_NACK",
    // (undocumented)
    LOGON_ACK = "LOGON_ACK",
    // (undocumented)
    LOGON_NACK = "LOGON_NACK",
    // (undocumented)
    LOGOUT_ACK = "LOGOUT_ACK",
    // (undocumented)
    LOGOUT_NACK = "LOGOUT_NACK",
    // (undocumented)
    MORE_COLUMNS = "MORE_COLUMNS",
    // (undocumented)
    MORE_COLUMNS_ACK = "MORE_COLUMNS_ACK",
    // (undocumented)
    MORE_ROWS = "MORE_ROWS",
    // (undocumented)
    MSG_ACK = "MSG_ACK",
    // (undocumented)
    MSG_NACK = "MSG_NACK",
    // (undocumented)
    QUERY_UPDATE = "QUERY_UPDATE"
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "MetaCache" because one of its declarations is marked as @internal
//
// @public
export type MetaCache = MetadataCache & JsonSchemaCache;

// @internal
export const MetaCache: InterfaceSymbol<MetaCache>;

// @public
export type Metadata = {
    FIELD?: MetadataDetail[];
    INDEXES?: IndexDetail[];
    REPLY_FIELD?: MetadataDetail[];
    REQUEST_FIELD?: MetadataDetail[];
    NAME?: string;
    TYPE?: string;
    ERROR?: string;
};

// @public
export interface MetadataCache {
    cachedMetadata: Map<string, Metadata>;
    getMetadataFor(resourceName: string): Metadata;
    hasMetadataFor(resourceName: string): boolean;
    setMetadataFor(resourceName: string, metadata: Metadata): void;
}

// @public
export type MetadataDetail = {
    NAME: string;
    TYPE: string;
    VALID_VALUES?: string;
    READ_ONLY?: boolean;
    OPTIONAL?: boolean;
    UI_LABEL?: string;
};

// @public (undocumented)
export type MetadataEvent = CustomEvent<MetadataEventDetail>;

// @public (undocumented)
export type MetadataEventDetail = {
    resourceName: string;
    message: Message<MessageDetails.MetaRequest>;
    error?: any;
};

// @public (undocumented)
export const MetadataEventType = "connect-metadata-event";

// @public
export type MonitoredResource = SocketObservable<any>;

// @public
export type MonitoredResourceChecks = (sourceRef: string, resource: MonitoredResource) => Promise<MonitoredResourceChecksResult>;

// @public
export interface MonitoredResourceChecksResult {
    // (undocumented)
    isConnected: boolean;
    // (undocumented)
    lastMessage?: Message;
    // (undocumented)
    lastUpdated: number;
    // (undocumented)
    timeout?: boolean;
}

// @public
export type MonitoredResourceDataLogon = (metadata: MonitoredResourceMetadata) => void;

// @public
export interface MonitoredResourceMetadata extends Partial<MonitoredResourceChecksResult>, Partial<StreamEventDetail> {
}

// @public (undocumented)
export const networkLogger: Logger;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "NetworkMonitor" because one of its declarations is marked as @internal
//
// @public
export interface NetworkMonitor {
    // (undocumented)
    addResource(resource: MonitoredResource, metadata: MonitoredResourceMetadata): void;
    // (undocumented)
    create(): void;
    // (undocumented)
    destroy(): void;
    // (undocumented)
    removeResource(resource: MonitoredResource): void;
    // (undocumented)
    runAllChecks(source?: unknown, force?: boolean): Promise<void>;
    // (undocumented)
    status: SystemHealthStatus;
}

// @internal
export const NetworkMonitor: InterfaceSymbol<NetworkMonitor>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "NetworkMonitorConfig" because one of its declarations is marked as @internal
//
// @public
export interface NetworkMonitorConfig {
    checkInterval?: number;
    checkTimeout?: number;
    documentEvents?: (keyof DocumentEventMap)[];
    eventEmitter?: HTMLElement;
    genesisConnectEvents?: GenesisConnectEvents[];
    resourceChecks?: MonitoredResourceChecks;
    resourceDataLogon?: MonitoredResourceDataLogon;
    windowEvents?: (keyof WindowEventHandlersEventMap)[];
}

// @internal
export const NetworkMonitorConfig: InterfaceSymbol<NetworkMonitorConfig>;

// @public
export function normaliseCriteria(criteria: string, delimiter?: string): string;

// @public
export interface PollingConfiguration {
    AMOUNT_OF_POLLS: number;
    QUERIES: string[];
    TEMP_FREQUENCY: number;
}

// @public
export type RawDataServerResult = {
    MESSAGE_TYPE: string;
    ROW: ServerRow[];
    SOURCE_REF: string;
    MORE_ROWS: boolean;
    ROWS_COUNT: number;
    SEQUENCE_ID: number;
};

// @public
export type RefreshAuthInfo = {
    type: AuthType & AuthType.REFRESH;
    username: string;
    refreshToken: string;
    mfaToken: string;
};

// @public
export type RefreshCredentialsInput = {
    username: string;
    refreshToken: string;
    mfaToken?: string;
};

// @public
export type RequestParams = {
    DETAILS?: any;
    REQUEST?: any;
};

// @public
export type RequestServerResult = {
    SOURCE_REF?: string;
    REPLY: any[];
    MESSAGE_TYPE?: string;
};

// @public
export type ResourceHealth = MonitoredResourceChecksResult & {
    name: string;
    sourceRef: string[];
    lastError?: any;
};

// @public
export enum ResourceType {
    // (undocumented)
    DATASERVER = "DATASERVER",
    // (undocumented)
    EVENT_HANDLER = "EVENT_HANDLER",
    // (undocumented)
    REQUEST_SERVER = "REQUEST_SERVER"
}

// @public
export const retryInterval: (reconnectOptions: SocketReconnectOptions, scheduler: SocketReconnectScheduler) => Observable<number>;

// @public
export type RowData = {
    ROW_REF: string;
};

// @public
export type SchemaResponse = {
    INBOUND: JSONSchema7;
    OUTBOUND: JSONSchema7;
    MESSAGE_TYPE: string;
    SOURCE_REF: string;
};

// @public
export interface SerializedSocketStatus {
    // (undocumented)
    readonly closedClean: boolean;
    // (undocumented)
    readonly closedCode: number;
    // (undocumented)
    readonly closedReason: string;
    // (undocumented)
    hasValidSession: boolean;
    isConfigured: boolean;
    // (undocumented)
    isConnected: boolean;
    // (undocumented)
    isConnecting: boolean;
    // (undocumented)
    isDisconnected: boolean;
    // (undocumented)
    isDisconnectedByServer: boolean;
    // (undocumented)
    isReconnecting: boolean;
    // (undocumented)
    reconnectionLimitReached: boolean;
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Serializer" because one of its declarations is marked as @internal
//
// @public
export interface Serializer {
    // @deprecated
    deserialize<T = any>(response: Response): Promise<T>;
    // @deprecated
    deserialize<T = any>(event: MessageEvent): T;
    // @deprecated
    deserialize<T = any>(text: string): T;
    // @deprecated
    serialize(object: any): string;
}

// @internal
export const Serializer: InterfaceSymbol<Serializer>;

// @public
export type ServerRow = {
    DETAILS: {
        OPERATION: 'INSERT' | 'MODIFY' | 'DELETE';
        ROW_REF: string;
    };
};

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Session" because one of its declarations is marked as @internal
//
// @public
export interface Session {
    captureReturnUrl(): void;
    deleteUserFromSessionStorage(): void;
    getItem(key: string | UserInfoKeys, storage: StorageType): string;
    getLocalStorageItem(key: string | UserInfoKeys): string;
    getSessionStorageItem(key: string | UserInfoKeys): string;
    removeItem(key: string | UserInfoKeys, storage: StorageType): void;
    removeLocalStorageItem(key: string | UserInfoKeys): void;
    removeSessionStorageItem(key: string | UserInfoKeys): void;
    returnUrl: string;
    setAuthResult(info: Message): void;
    setItem(key: string | UserInfoKeys, value: string, storage: StorageType): void;
    setLocalStorageItem(key: string | UserInfoKeys, value: string): void;
    setSessionStorageItem(key: string | UserInfoKeys, value: string): void;
    setStorageKeyPrefix(prefix: string): void;
}

// @internal
export const Session: InterfaceSymbol<Session>;

// Warning: (ae-internal-missing-underscore) The name "SessionMock" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class SessionMock implements Session {
    // (undocumented)
    captureReturnUrl(): void;
    // (undocumented)
    deleteUserFromSessionStorage(): void;
    // (undocumented)
    getItem(key: string): string;
    // (undocumented)
    getLocalStorageItem(key: string): string;
    // (undocumented)
    getSessionStorageItem(key: string): string;
    // (undocumented)
    nextStorageItem: string;
    // (undocumented)
    removeItem(key: string): void;
    // (undocumented)
    removeLocalStorageItem(key: string): void;
    // (undocumented)
    removeSessionStorageItem(key: string): void;
    // (undocumented)
    returnUrl: string;
    // (undocumented)
    setAuthResult(loginResult: Message): void;
    // (undocumented)
    setItem(key: string, value: string): void;
    // (undocumented)
    setLocalStorageItem(key: string, value: string): void;
    // (undocumented)
    setSessionStorageItem(key: string, value: string): void;
    // (undocumented)
    setStorageKeyPrefix(prefix: string): void;
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "Socket" because one of its declarations is marked as @internal
//
// @public
export interface Socket extends Omit<SocketStatus, 'serialize' | 'onClose' | 'reconnectionLimitReached' | 'closedCode' | 'closedReason' | 'closedClean'> {
    // (undocumented)
    connect(host: string, options?: SocketConnectOptions, reconnectOptions?: SocketReconnectOptions): Promise<boolean>;
    reset(): void;
    // (undocumented)
    send<T>(message: Message<T | any>, needsHandling?: boolean): Promise<Message | any>;
    // (undocumented)
    sendForStream<T>(message: Message<T | any>, onMessage: Function, onError: Function, onComplete?: Function): Observable<Message>;
    // (undocumented)
    socketMessages(): SocketSubject<Message>;
}

// @internal
export const Socket: InterfaceSymbol<Socket>;

// @public
export type SocketConnectOptions = {
    alwaysOn?: boolean;
    connectObserver?: Observer_2<Message>;
    enableHeartbeat?: boolean;
    enableHeartbeatLogging?: boolean;
    enableMessageLogging?: boolean;
    heartbeatInterval?: number;
    proxyPath?: string;
};

// @public
export class SocketMessageHandler {
    constructor(message: Message, onMessage: Function, onError: Function, isSubscription: boolean);
    get isSubscription(): boolean;
    get onReceivedError(): Function;
    get onReceivedMessage(): Function;
    get sentMessage(): Message;
}

// Warning: (ae-internal-missing-underscore) The name "SocketMock" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class SocketMock implements Socket {
    // (undocumented)
    connect(host: string, options?: SocketConnectOptions, reconnectOptions?: SocketReconnectOptions): Promise<boolean>;
    // (undocumented)
    disconnect(): void;
    // (undocumented)
    hasValidSession: boolean;
    // (undocumented)
    isConfigured: boolean;
    // (undocumented)
    isConnected: boolean;
    // (undocumented)
    isConnectedSubject: BehaviorSubject<boolean>;
    // (undocumented)
    isConnecting: boolean;
    // (undocumented)
    isDisconnected: boolean;
    // (undocumented)
    isDisconnectedByServer: boolean;
    // (undocumented)
    isReconnecting: boolean;
    // (undocumented)
    nextMessage: Message;
    // (undocumented)
    reset(): void;
    // (undocumented)
    send<T>(message: Message<any>): Promise<Message | any>;
    // (undocumented)
    sendForStream<T>(message: Message<any>, onMessage: Function, onError: Function, onComplete?: Function): Observable<Message>;
    // (undocumented)
    socketMessages(): SocketSubject<Message>;
    // (undocumented)
    socketMessagesSubject: SocketSubject<Message<any>>;
}

// @public
export class SocketObservable<T> extends Observable<T> {
    constructor(...args: any[]);
}

// @public
export type SocketReconnectOptions = {
    reconnectAttempts?: number;
    reconnectInterval?: number;
    reconnectObserver?: Observer_2<any>;
    reconnectStreams?: boolean;
    reconnectStrategy?: SocketReconnectStrategy;
};

// @public
export type SocketReconnectScheduler = (reconnectOptions: SocketReconnectOptions, attempts?: number) => number;

// @public
export enum SocketReconnectStrategy {
    // (undocumented)
    Exponential = "exponential",
    // (undocumented)
    Linear = "linear"
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "SocketStatus" because one of its declarations is marked as @internal
//
// @public
export interface SocketStatus extends SerializedSocketStatus {
    // (undocumented)
    isConnectedSubject: BehaviorSubject<boolean>;
    // (undocumented)
    onClose(closeEvent: CloseEvent): void;
    // (undocumented)
    serialize(): SerializedSocketStatus;
}

// @internal
export const SocketStatus: InterfaceSymbol<SocketStatus>;

// @public
export class SocketSubject<T> extends Subject<T> {
    constructor();
}

export { SocketSubscription }

// @public
export type SsoAuthInfo = {
    type: AuthType & AuthType.SSO;
    ssoToken: string;
};

// @public
export type SSOCredentialsInput = {
    ssoToken: string;
};

// @public
export type StorageType = 'local' | 'session';

// @public (undocumented)
export type StreamCompleteEvent = CustomEvent<SocketObservable<any>>;

// @public (undocumented)
export const StreamCompleteEventType = "connect-stream-complete-event";

// @public (undocumented)
export type StreamEvent = CustomEvent<StreamEventDetail>;

// @public (undocumented)
export type StreamEventDetail = {
    functions: StreamEventFunctions;
    message: Message<MessageDetails.DataserverRequest>;
    resourceName: string;
    stream: SocketObservable<any>;
};

// @public (undocumented)
export type StreamEventFunctions = {
    onMessage?: Function;
    onError?: Function;
    resourceChecks?: MonitoredResourceChecks;
    resourceDataLogon?: MonitoredResourceDataLogon;
};

// @public (undocumented)
export const StreamEventType = "connect-stream-event";

// @public
export const SystemHealthChanged = "system-health-changed";

// @public
export type SystemHealthChangedEvent = CustomEvent<SystemHealthStatus>;

// @public
export type SystemHealthStatus = {
    isOnline: boolean;
    browserInformation?: Bowser_2.Parser.ParsedResult;
    isAuthenticated: boolean;
    username?: string;
    isHealthy: boolean;
    socket: SerializedSocketStatus;
    resources: Record<string, ResourceHealth>;
    resourcesAllConnected: boolean;
    lastUpdated: number;
    nextUpdate: number;
    firstUpdated: number;
    runAllChecks(): void;
    reportStabilityToGenesis(): Promise<boolean>;
};

// @public
export const toFieldMetadata: (fieldDef: MetadataDetail[]) => FieldMetadata[];

// @public
export const TYPES_MAP: {
    STRING: FieldTypeEnum;
    ENUM: FieldTypeEnum;
    BOOLEAN: FieldTypeEnum;
    INT: FieldTypeEnum;
    LONG: FieldTypeEnum;
    DOUBLE: FieldTypeEnum;
    BIGDECIMAL: FieldTypeEnum;
    DATE: FieldTypeEnum;
    DATETIME: FieldTypeEnum;
};

// Warning: (ae-internal-missing-underscore) The name "UnknownUserPermissions" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type UnknownUserPermissions = string;

// Warning: (ae-internal-missing-underscore) The name "UnknownUserProfiles" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type UnknownUserProfiles = string;

// @public
export function until(conditionFunc: () => boolean, timeoutMs?: number): Promise<any>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "User" because one of its declarations is marked as @internal
//
// @public
export interface User extends UserOptions {
    // (undocumented)
    hasAdminProfile(): boolean;
    // Warning: (ae-incompatible-release-tags) The symbol "hasPermission" is marked as @public, but its signature references "UserPermission" which is marked as @internal
    //
    // (undocumented)
    hasPermission(permission: UserPermission | UserPermission[]): boolean;
    // Warning: (ae-incompatible-release-tags) The symbol "hasProfile" is marked as @public, but its signature references "UserProfile" which is marked as @internal
    //
    // (undocumented)
    hasProfile(profile: UserProfile | UserProfile[]): boolean;
    // (undocumented)
    set(options: UserOptions): void;
    // (undocumented)
    unset(): void;
}

// @internal
export const User: InterfaceSymbol<User>;

// Warning: (ae-internal-missing-underscore) The name "UserPermission" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type UserPermission = CoreUserPermissions | UnknownUserPermissions;

// Warning: (ae-internal-missing-underscore) The name "UserProfile" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type UserProfile = CoreUserProfiles | UnknownUserProfiles;

// Warning: (ae-internal-missing-underscore) The name "WSConnect" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export const WSConnect: InterfaceSymbol<Connect>;

// (No @packageDocumentation comment for this package)

```
